/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.shared;

import org.bukkit.util.Vector;

import java.util.Objects;

public class RoundedPosition {

    private static final long factor = 10;

    private long x;
    private long y;
    private long z;

    public RoundedPosition(Position position) {
        this(position.getLocation().getX(), position.getLocation().getY(), position.getLocation().getZ());
    }

    public RoundedPosition(Position position, int factor) {
        this(position.getLocation().getX(), position.getLocation().getY(), position.getLocation().getZ(), factor);
    }

    public RoundedPosition(Vector vector) {
        this(vector.getX(), vector.getY(), vector.getZ());
    }

    public RoundedPosition(Vector vector, int factor) {
        this(vector.getX(), vector.getY(), vector.getZ(), factor);
    }

    public RoundedPosition(double x, double y, double z) {
        this.x = (long) (x * factor);
        this.y = (long) (y * factor);
        this.z = (long) (z * factor);
    }

    public RoundedPosition(double x, double y, double z, long factor) {
        if (factor == -1) {
            this.x = Double.doubleToLongBits(x);
            this.y = Double.doubleToLongBits(y);
            this.z = Double.doubleToLongBits(z);
        } else {
            this.x = (long) (x * factor);
            this.y = (long) (y * factor);
            this.z = (long) (z * factor);
        }
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof RoundedPosition)) return false;
        RoundedPosition that = (RoundedPosition) o;
        return x == that.x &&
                y == that.y &&
                z == that.z;
    }

    @Override
    public int hashCode() {
        return Objects.hash(x, y, z);
    }

}
